#!/usr/bin/perl  -U

###############################################################
#Proyecto de Tesis Auditoria Administrativa

#Copyright (C)2002 Cynthia Gabriela Pardo Orozco FCA-UNAM

#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
###############################################################

use Pg;
use CGI qw(:standard);
use pemes::inicializar;

$JSCRIPT = <<EOF;
var destQAL = document.editQALForm.destQAL;
var ie = document.all?1:0;
var submited = 0;


function AddToTheList() 
{
    var fromAB = document.editQALForm.fromAB;
    var destQAL= document.editQALForm.destQAL;
    var selectedValue = "";
    var selectedText = "";
    if ( fromAB.selectedIndex < 0)
    {
    alert("Por favor, primero seleccione un elemento de la lista");
    if (fromAB.options[0] != null)
	fromAB.options[0].selected = true;
    fromAB.focus();
    return false;
}
    else
{       
    selectedValue = fromAB.options[fromAB.selectedIndex].value;
    selectedText = fromAB.options[fromAB.selectedIndex].text;
    destQAL.options[destQAL.length] = new Option(selectedText,selectedValue);
    fromAB.options[fromAB.selectedIndex] = null;
}

}
function RemoveFromTheList() 
{
    var fromAB = document.editQALForm.fromAB;
    var destQAL= document.editQALForm.destQAL;
    var selectedValue = "";
    var selectedText = "";
    if ( destQAL.selectedIndex < 0)
    {
	alert("Por favor, primero seleccione un elemento de la lista");
	if (destQAL.options[0] != null)
	    destQAL.options[0].selected = true;
	destQAL.focus();
	return false;
    }
    else
    {
	selectedValue = destQAL.options[destQAL.selectedIndex].value;
	selectedText = destQAL.options[destQAL.selectedIndex].text;
	fromAB.options[fromAB.length] = new Option(selectedText,selectedValue);
	destQAL.options[destQAL.selectedIndex] = null;
    }

}
function disapleButtons()
{
    var fromAB = document.editQALForm.fromAB;
    var destQAL= document.editQALForm.destQAL;
    if (fromAB.options.length > 0 )
    {
	if (destQAL.options.length < 5)
	    document.editQALForm.AddQ.disabled = 0;
	else
	    document.editQALForm.AddQ.disabled = 1;
    }
    else
	document.editQALForm.AddQ.disabled = 1;
    if (destQAL.options.length > 0)
	document.editQALForm.RemoveQ.disabled = 0;
    else
	document.editQALForm.RemoveQ.disabled = 1;
}
function putItTogether()
{
    var destQAL= document.editQALForm.destQAL;
    var fullList = "";
    for(var i = 0; i < destQAL.length; i++) 
    {
	fullList += (destQAL.options[i].text + "::");   
    }
    fullList = fullList.substring(0, fullList.length-2);
    document.editQALForm.quickaddr.value = fullList;
    document.editQALForm.submit();
}
disapleButtons();

function guardaSelect(){
    var miForma = document.editQALForm;    
    var longitud=miForma.destQAL.length;
    var i=0;
    var ids="";

    while (i < longitud){
    
	ids=miForma.destQAL.options[i].value+":"+ids ;
 
	i++;

    }
    miForma.ids_fact.value=ids;
  
    miForma.submit();

}    
EOF
;




#abre conexion
$conn = Pg::connectdb("dbname=auditoria user=pardo");

$query = new CGI;

print $query->header;

print start_html(-title=>'Seleccion de Factores Audit-Admin',
                 -script=>$JSCRIPT);

$accion = $query->param(accion);
$id_normal = $query->param(dato_id);
$id_audit = $query->param(audit);
$ids_fact = $query->param(ids_fact);


@variables = &prueba();
#variables que crean el formato de la pagina que se despliega    
$page_up = $variables[0];
$page_down = $variables[1];
#botones para el regreso
$locacion1 = $variables[2];
$locacion2 = $variables[3];    
$locacion3 = $variables[4];
$botones = $variables[5];
#terminan los formatos de la pagina




######################################
#Este es para checar el tipo de usuario
######################################

 Pg::doQuery($conn,"select * from usuarios where id_usuario =$id_normal",\@datosUser);

#si no llego el id o llego pero no es un usuario del tipo administrador, se desecha
#   el id es:$datosUser[0][0]
#   el nombre$datosUser[0][1]
#   AP$datosUser[0][2]<br>
#   AM$datosUser[0][3]<br>
#   LOG$datosUser[0][4]<br>
#   PASS$datosUser[0][5]<br>
#   TIPO$datosUser[0][6]<br>
#   GRUPO$datosUser[0][7]<br>


#usuario no es del tipo correcto
if ($id_normal eq "" ||$datosUser[0][6] ne "1" ){
    $contents = "Los datos de validacion de usuario para ejecutar este modulo no llegaron completos o no fueron insertados, consulte con el administrador del sistema o  <a href=valida.pl?accion=1>vuelva a intentar.</a>\n<br> <br> ";

    print $page_up.$contents.$page_down;	
}else{
  ####################################
  #Si accion viene sin ningun contenido
  ###################################
  if($accion == 1){

    #  para recoger los id's de las factores seleccionadas
      $ids_fact = $query->param(ids_fact);
      $cadenita = $ids_fact;    
      @ids_fact1 = split(/:/, $ids_fact);
      $longitud = scalar(@ids_fact1);

    #verifica si hay puntos asignados a los factores pesos
    Pg::doQuery($conn,"select sum(puntos) from distrib_puntos  where  id_auditoria=$id_audit",\@puntos);


      if( $puntos[0][0] > 0 ){
	  print $page_up."Las factores seleccionadas contienen pesos asignados, es necesario vaciar los puntos para editar nuevamente las factores \n";

	  print $botones.$page_down;		  

      }else{
	  
      #borra las factores existentes 
	Pg::doQuery($conn,"delete from distrib_puntos  where  id_auditoria=$id_audit",\@puntos);
      #busca las subfunciones de la auditoria
	Pg::doQuery($conn,"select id_sub from ponderacion_sub where id_auditoria=$id_audit",\@idSubAudit);
	  $lenSubAudit = scalar(@idSubAudit);
      #inserta los nuevos factores
	  $x = 0;
	  $y = 0;
	  while ($x < $longitud ){
	      while ($y < $lenSubAudit ){      
		Pg::doQuery($conn,"insert into distrib_puntos (id_auditoria,id_sub,id_factor) values($id_audit,'$idSubAudit[$y][0]','$ids_fact1[$x]')");
		  $y++;   
	      } 
	      $y=0;
	      $x++;   
      }
	   
	 #para traer el nombre de la empresa
	Pg::doQuery($conn,"select nombre_emp from empresa where id_empresa in (select id_empresa from auditoria where id_auditoria=$id_audit)",\@nombreEmp);
	   
	  print $page_up."La insercion de factores en la empresa <b>\" $nombreEmp[0][0] \"</b> se realizo con exito<br>\n"; 

	  print $botones.$page_down;
      }

  }else{


     #trae los factores existentes en los catalogos del sistema
    Pg::doQuery($conn,"select id_factor,nombre from cat_factores where id_factor not in (select id_factor from distrib_puntos where id_auditoria=$id_audit) order by nombre",\@factoresCat);

	#trae los factores existentes en la auditoria
    Pg::doQuery($conn,"select id_factor,nombre from cat_factores where id_factor  in (select id_factor from distrib_puntos where id_auditoria=$id_audit) order by nombre",\@factores);	  


      $x = 0;	    
      $num_factores = @factoresCat ;
      if ($num_factores > 10){
	  $num = 10;
      }else{
	  $num = $num_factores;
	  if($num == 0){
	      $num = scalar(@factores);
	  }
      }
      if($num > 0){
	   ############################################
	   #trae las subfunciones existentes en la auditoria,"debe haberlas"
	   #de lo contrario no es posible asignar factores
	   ##############################################
	Pg::doQuery($conn,"select id_auditoria from  ponderacion_sub where id_auditoria=$id_audit and id_sub > 0 and porcentaje > 0",\@subExist);         

	  if($subExist[0][0] eq ""){
	      print $page_up;	  
	      print "<p>No es posible agregar factores sin haber agregado subfunciones y pesos a la auditoria</p>&nbsp;";
	      print $botones.$page_down;	  
	  }else{
	      $contents_up = "
           - MODULO DE OPERACIONES CON AUDITORIAS - AUDIT-ADMIN \n 
           <p>\n
           <form method=post name=\"editQALForm\">\n
           <table><tr>
             <td colspan=2>            <input type=\"button\" name=\"listaPrint\" value=\"Lista de Impresion de Factores\" onClick=\"window.open('imprime.pl?dato_id=$id_normal&tipo=fac&id_auditoria=$id_audit','variable','width=600,height=450,scrollbars=yes,toolbar=yes')\"> </td></tr>
<tr>\n
           <td valign=\"middle\" align=\"center\">\n
           Agregue los Factores que requiera su Auditoria:<br> \n
           <SELECT NAME=\"fromAB\" size=\"10\" width=\"300px\" style=\"width:300px;\" ><br>\n";
	      print $page_up.$contents_up;
	  
	      while ( $factoresCat[$x][0] ne "" ) {
	    
		  print "<OPTION value=$factoresCat[$x][0]>$factoresCat[$x][1] \n";

		  $x++;
	      }
	  
	      $contents_down = "</SELECT></td>";
	  
	      print $contents_down;
	      $contents2 = "<td valign=\"middle\" align=\"center\"><br>\n
           <input class=\"sbttn\" style=\"width: 75px;\" type=\"button\" value=\"Agregar \" name=\"AddQ\" onClick=\"AddToTheList();\"><p>\n
           <input class=\"sbttn\" style=\"width: 75px;\" type=\"button\" value=\"&laquo; Quitar\" name=\"RemoveQ\" onClick=\"RemoveFromTheList();\">\n
           </td><td valign=\"middle\" align=\"center\">\n";
	  
	      print $contents2;
	  
	      print "Factores elegidos:<br><SELECT NAME=\"destQAL\" size=\"10\" width=\"300px\" style=\"width:300px;\"><br>\n";
	      $x = 0;
	      while ( $factores[$x][0] ne "" ) {   
		  print "<OPTION value=$factores[$x][0]>$factores[$x][1] \n";
		  $x ++;
	      }
	  
	      $contents2_down = "</select></td></tr></table>\n
              <input class=\"sbttn\" style=\"width: 75px;\" type=\"button\" value=\"Guardar\" name=\"Guardar\" onClick=\"guardaSelect();\n\">
              <input type=\"hidden\" name=\"dato_id\" value=\"$id_normal\">\n
              <input type=\"hidden\" name=\"audit\" value=\"$id_audit\">\n
              <input type=\"hidden\" name=\"ids_fact\" value=\"\">\n
              <input type=\"hidden\" name=\"accion\" value=1>\n
              </form>\n";
	  
	      print $contents2_down.$botones.$page_down;
	  }
      }else {
#cuando no existen auditorias creadas.
	  print $page_up;
	  print "No hay auditorias existentes<br>\n
          Requiere crear una nueva auditoria previamente";
	  print $empresas[$x][0];
	  print $botones.$page_down;	  
      }
  }

}
#cierre del else 

exit;
