#!/usr/bin/perl  -U

###############################################################
#Proyecto de Tesis Auditoria Administrativa

#Copyright (C)2002 Cynthia Gabriela Pardo Orozco FCA-UNAM

#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
###############################################################

use Pg;
use CGI qw(:standard);
use pemes::inicializar;

###############################################################
#la siguiente funcion javascript sirve para cambiar la pagina de
#manera automatica una vez que el usuario ha elegido una operacion
#a realizar, enviando los datos necesarios.
###############################################################

$JSCRIPT=<<EOF;

function spawnWin(options) {
 var url = options[
  options.selectedIndex
  ].value;
 parent.location.href= url;
}
 

 
EOF
; 


$conn = Pg::connectdb("dbname=auditoria user=pardo");

$query = new CGI;
print $query->header;
print start_html(-title=>'Personal Profile',
                 -script=>$JSCRIPT);

$accion = $query->param(accion);
$id_normal = $query->param(dato_id);


@variables= &prueba();
#variables que crean el formato de la pagina que se despliega    
$page_up=$variables[0];
$page_down=$variables[1];
#botones para el regreso
$locacion1=$variables[2];
$locacion2=$variables[3];    
$locacion3=$variables[4];
$botones=$variables[5];
#terminan los formatos de la pagina




Pg::doQuery($conn,"select * from usuarios where id_usuario =$id_normal",\@datosUser);

#si no llego el id o llego pero no es un usuario del tipo administrador, se desecha
  #   el id es:$datosUser[0][0]  
  #   el nombre$datosUser[0][1]
  #   AP$datosUser[0][2]<br>
  #   AM$datosUser[0][3]<br>
  #   LOG$datosUser[0][4]<br>
  #   PASS$datosUser[0][5]<br>
  #   TIPO$datosUser[0][6]<br>
  #   GRUPO$datosUser[0][7]<br>

if ($id_normal eq "" || $datosUser[0][6] ne "1"){
   $contents="Los datos de validacion de usuario para ejecutar este modulo no llegaron completos o no fueron insertados, consulte con el administrador del sistema o  <a href=valida.pl?accion=1>vuelva a intentar.</a>\n<br>
   ";

   print $page_up.$contents.$botones.$page_down;	
}else{
 if($accion ne "2" && $accion ne "3"){
  #modificacion de los datos dela empresa

    Pg::doQuery($conn,"select id_empresa,nombre_emp from empresa where id_empresa not in (select id_empresa from auditoria)",\@empresas);
    print $page_up;
	 
   if($dimension=@empresas > 0){
     if($dimension < 10){
	  $longitud=$dimension;
     }else {
	  $longitud=10;
     }
     print "<form>El siguiente listado solo presenta empresas a las que no se han asignado auditorias. Si la empresa que busca no se encuentra en el listado puede significar que tiene auditorias asignadas. Seleccione empresa a modificar:
    <div align=center>
    <SELECT NAME=\"usuarios\" size=\"$longitud\" onChange=\"spawnWin(this.options)\" ><br>";
              print "<OPTION>Elija:\n";
     $x = 0;
       while ( $empresas[$x][0] ne "" ) {

              print "<OPTION value=opEmpChange.pl?dato_id=$id_normal\&id=$empresas[$x][0]&accion=2>\"$empresas[$x][1]\"\n";

          $x++;
       }
     print "</SELECT>
     </div>

     </form><br><br>";

     print $botones.$page_down;
	
 	}else{#si no hay empresas para modificar

	   print "Por el momento no existen empresas con permiso para ser editadas, verifique que la empresa por seleccionar no este siendo utilizada por una auditoria";
        print $botones.$page_down;    
	}#cierre else de empresas a modificar
	    

    }elsif($accion eq "2"){
       print $page_up;
	 
     $id = $query->param(id);
	# print "has llegado camarada el id de la  empresa es $id";
     Pg::doQuery($conn,"select id_clas,id_giro,id_est,id_del,nombre,nombre_emp,telefono,a_paterno,a_materno,fecha_fundacion,calle,numero,colonia,cp,municipio from empresa where id_empresa='$id'",\@datos_empresa);

      $nameEmpresa = $datos_empresa[0][5];
      $dateFundation = $datos_empresa[0][9];
      $clasificacion1 =$datos_empresa[0][0];
      Pg::doQuery($conn,"select id_clas,descripcion from clasificacion where id_clas='$clasificacion1'",\@clasifEmp);
	  
      $giro1 =$datos_empresa[0][1];
      Pg::doQuery($conn,"select id_giro,descripcion from giro where id_giro='$giro1'",\@giroEmp);	  	  	  
      $nameContact =$datos_empresa[0][4];        
      $firstContact =$datos_empresa[0][7];
      $secondContact =$datos_empresa[0][8];    
      $phoneContact =$datos_empresa[0][6];
      $streetEmpresa =$datos_empresa[0][10];
      $numberEmpresa =$datos_empresa[0][11];
      $coloniaEmpresa =$datos_empresa[0][12];
      $cpEmpresa =$datos_empresa[0][13];
      $municipioEmpresa =$datos_empresa[0][14];
      $estateEmpresa1 =$datos_empresa[0][2];
      Pg::doQuery($conn,"select id_est,nombre from estado where id_est='$estateEmpresa1'",\@estateEmp);	  	  	  
      $delegacionEmpresa1 =$datos_empresa[0][3];
      Pg::doQuery($conn,"select id_del,nombre from delegacion where id_del='$delegacionEmpresa1'",\@delEmp);	  	  	  

	  #////////
    Pg::doQuery($conn,"select id_clas,descripcion from clasificacion",\@clasificacion);
    Pg::doQuery($conn,"select id_giro,descripcion from giro",\@giro);
    Pg::doQuery($conn,"select id_est,nombre from estado",\@estado);
    Pg::doQuery($conn,"select id_del,nombre from delegacion",\@delegacion);
    
    $contents_up="
     MODULO DE MODIFICACION  DE DATOS   EMPRESAS AUDIT-ADMIN
    <form name=\"forma\" action=\"opEmpChange.pl\">
     Para dar insertar empresas es necesario llenar los siguientes datos:<br>
     <table>
     <tr><td><p>Nombre de la Empresa<br>
     <textarea name=\"nombreEmp\" wrap=\"hard\"rows=\"3\" cols=\"50\">$nameEmpresa</textarea></p></td>
     <td><p>Fecha de fundaci&oacute;n  \"dd/mm/aaaa\"<br><input type=\"text\" value=\"$dateFundation\" name=\"fechaFundacion\" maxlength=10 size=10></p></td></tr>
     <tr><td>Clasificaci&oacute;n<br>
     <select name=\"clasificacion\">
     ";
    
	 print $contents_up;
      print "<option value=$clasifEmp[0][0]>$clasifEmp[0][1] \n"; 	  	  
	 $x=0;
	 while($clasificacion[$x][0] ne ""){
      
      print "<option value=$clasificacion[$x][0]>$clasificacion[$x][1]\n"; 

	   $x= $x + 1;	   
	 }
      print "</select></td><td>Giro<br><select name=\"giro\">";
	 $x=0;
      print "<option value=$giroEmp[0][0]>$giroEmp[0][1]\n"; 	  
	 while($giro[$x][0] ne ""){
      
      print "<option value=$giro[$x][0]>$giro[$x][1]\n"; 

	   $x= $x + 1;	   
	 }
      print "</select></td></tr>"; 	 
	 
	 
     $contents_down="<tr><td><hr><p>Nombre del Contacto<br>
     <input type=\"text\" name=\"nombreContacto\" value=\"$nameContact\" maxlength=\"50\" size=\"50\"></p>
     </td><td><hr><p>Apellido Paterno<br>
     <input type=\"text\" name=\"aPaterno\" value=\"$firstContact\"  maxlength=\"50\" size=\"50\"></p>
     </td></tr><tr><td><p>Apellido Materno<br>
     <input type=\"text\" name=\"aMaterno\" value=\"$secondContact\" maxlength=\"50\" size=\"50\"></p>
     </td><td><p>Tel&eacute;fono<br>
     <input type=\"text\" name=\"telefono\" value=\"$phoneContact\" maxlength=\"21\" size=\"21\">
     <input type=\"hidden\" name=\"dato_id\" value=$id_normal>
     <input type=\"hidden\" name=\"accion\" value=3></td></tr>
     <input type=\"hidden\" name=\"id\" value=$id></td></tr>
     <tr><td>
     <hr>Domicilio de la Empresa<br>Calle<br>
     <input type=\"text\" name=\"calle\" value=\"$streetEmpresa\" maxlength=\"50\" size=\"50\"></td>
     <td><hr>N&uacute;mero<br>
     <input type=\"text\" name=\"numero\" value=\"$numberEmpresa\" maxlength=\"4\" size=\"4\"></td>
     </tr><tr><td>Colonia<br>
     <input type=\"text\" name=\"colonia\" value=\"$coloniaEmpresa\" maxlength=\"50\" size=\"50\"></td>
     <td>C&oacute;digo Postal<br>
     <input type=\"text\" name=\"cp\" value=\"$cpEmpresa\" maxlength=\"5\" size=\"5\"></td></tr>
     <tr><td>Municipio<br>
     <input type=\"text\" name=\"municipio\" value=\"$municipioEmpresa\" maxlength=\"50\" size=\"50\"></td></tr>";


    print $contents_down;
    print " <tr><td>Estado<br>
     <select name=\"estado\">
     ";
      print "<option value=$estateEmp[0][0]>$estateEmp[0][1]\n"; 
	 $x=0;
	 while($estado[$x][0] ne ""){
      
      print "<option value=$estado[$x][0]>$estado[$x][1]\n"; 

	   $x= $x + 1;	   
	 }
      print "</select></td><td>Delegaci&oacute;n<br><select name=\"delegacion\">
      <option value=$delEmp[0][0]>$delEmp[0][1]
      ";
	 $x=0;
	 while($delegacion[$x][0] ne ""){
      
      print "<option value=$delegacion[$x][0]>$delegacion[$x][1]\n"; 

	   $x= $x + 1;	   
	 }
      print "</select></td></tr>
      <tr><td colspan=2 align=\"center\"><input type=\"submit\" value=\"Guardar Cambios\"> </td></tr>
      </form></table>"; 	 	 

	  #///////
	 
	  print $botones.$page_down;


	}elsif($accion eq "3"){
    $id = $query->param(id);	  
    $nameEmpresa = $query->param(nombreEmp);
    $dateFundation = $query->param(fechaFundacion);
    $clasificacion = $query->param(clasificacion);
    $giro = $query->param(giro);
    $nameContact = $query->param(nombreContacto);        
    $firstContact = $query->param(aPaterno);
    $secondContact = $query->param(aMaterno);    
    $phoneContact = $query->param(telefono);
    $streetEmpresa = $query->param(calle);
    $numberEmpresa = $query->param(numero);
    $coloniaEmpresa = $query->param(colonia);
    $cpEmpresa = $query->param(cp);
    $municipioEmpresa = $query->param(municipio);
    $estateEmpresa = $query->param(estado);
    $delegacionEmpresa = $query->param(delegacion);

    $contents="Los datos recibidos y actualizados son:<br>
    <table>
    <tr><td>ID:</td><td> $id </tr>
    <tr><td>Nombre de la empresa:</td><td> $nameEmpresa </tr>
    <tr><td>Fecha de fundacion:</td><td> $dateFundation </tr>
    <tr><td>Clasificacion:</td><td> $clasificacion </tr>
    <tr><td>Giro :</td><td>$giro  </tr>
    <tr><td>Nombre del contacto:</td><td> $nameContact </tr>        
    <tr><td>Apellido Paterno del contacto:</td><td> $firstContact </tr>
    <tr><td>Apellido Materno del contacto:</td><td> $secondContact </tr>    
    <tr><td>Telefono del contacto:</td><td> $phoneContact </tr>
    <tr><td colspan=2>DOMICILIO DE LA ORGANIZACION:</tr>
    <tr><td>Calle: </td><td>$streetEmpresa </tr>
    <tr><td>Numero:</td><td> $numberEmpresa </tr>
    <tr><td>Colonia:</td><td> $coloniaEmpresa </tr>
    <tr><td>Cp:</td><td> $cpEmpresa </tr>
    <tr><td>Municipio:</td><td> $municipioEmpresa </tr>
    <tr><td>Estado:</td><td> $estateEmpresa </tr>
    <tr><td>Delegacion:</td><td> $delegacionEmpresa </tr>
    </table>
    ";

    #    $nameEmpresa <br>
    #    $dateFundation <br>
    #    $clasificacion <br>
    #    $giro  <br>
    #    $nameContact <br>        
    #    $firstContact <br>
    #    $secondContact <br>    
    #    $phoneContact <br>
    #    $streetEmpresa <br>
    #    $numberEmpresa <br>
    #    $coloniaEmpresa <br>
    #    $cpEmpresa <br>
    #    $municipioEmpresa <br>
    #    $estateEmpresa <br>
    #    $delegacionEmpresa 




    Pg::doQuery($conn,"update  empresa set id_clas='$clasificacion',id_giro='$giro',id_est='$estateEmpresa',id_del='$delegacionEmpresa',nombre='$nameContact',nombre_emp='$nameEmpresa',telefono='$phoneContact',a_paterno='$firstContact',a_materno='$secondContact',fecha_fundacion='$dateFundation',calle='$streetEmpresa',numero='$numberEmpresa',colonia='$coloniaEmpresa',cp='$cpEmpresa',municipio='$municipioEmpresa' where id_empresa='$id'");
        $nameEmpresa ="";
      $dateFundation = "";
      $clasificacion1 ="";	  
      $giro1 ="";
      $nameContact ="";        
      $firstContact ="";
      $secondContact ="";    
      $phoneContact ="";
      $streetEmpresa ="";
      $numberEmpresa ="";
      $coloniaEmpresa ="";
      $cpEmpresa ="";
      $municipioEmpresa ="";
      $estateEmpresa1 ="";
#    print "update  empresa set id_clas='$clasificacion',id_giro='$giro',id_est='$estateEmpresa',id_del='$delegacionEmpresa',nombre='$nameContact',nombre_emp='$nameEmpresa',telefono='$phoneContact',a_paterno='$firstContact',a_materno='$secondContact',fecha_fundacion='$dateFundation',calle='$streetEmpresa',numero='$numberEmpresa',colonia='$coloniaEmpresa',cp='$cpEmpresa',municipio='$municipioEmpresa' where id_empresa='$id'";

    #para cambiar el valor del estatus
#    Pg::doQuery($conn,"select estatus from grupos where id_grupo='$grupoUser'",\@estatus);
#    $estatus=$estatus[0][0]+1;
  
#    Pg::doQuery($conn,"update grupos set estatus='$estatus' where id_grupo='$grupoUser'");
    $boton="<form><input type=\"button\" value=\"Insertar Otra empresa\" onclick=\"parent.location.href='opEmpInsert.pl?dato_id=$id_normal'\" ></form>";
  
    print $page_up.$contents.$boton.$botones.$page_down;  
	
    


	  }

}#cierre del else 
 
exit;
