#!/usr/bin/perl  -U

###############################################################
#Proyecto de Tesis Auditoria Administrativa

#Copyright (C)2002 Cynthia Gabriela Pardo Orozco FCA-UNAM

#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
###############################################################

use Pg;
use CGI qw(:standard);
use pemes::inicializar;

###############################################################
#la siguiente funcion javascript sirve para cambiar la pagina de
#manera automatica una vez que el usuario ha elegido una operacion
#a realizar, enviando los datos necesarios.
###############################################################
$JSCRIPT=<<EOF;

function spawnWin(options) {
    var url = options[options.selectedIndex].value;
    parent.location.href= url;
}
 

 
EOF
; 


$conn = Pg::connectdb("dbname=auditoria user=pardo");

$query = new CGI;
print $query->header;
print start_html(-title=>'Personal Profile',
                 -script=>$JSCRIPT);

$accion = $query->param(accion);
$id_normal = $query->param(dato_id);


@variables = &prueba();
#variables que crean el formato de la pagina que se despliega    
$page_up = $variables[0];
$page_down = $variables[1];
#botones para el regreso
$locacion1 = $variables[2];
$locacion2 = $variables[3];    
$locacion3 = $variables[4];
$botones = $variables[5];
#terminan los formatos de la pagina




Pg::doQuery($conn,"select * from usuarios where id_usuario =$id_normal",\@datosUser);

#si no llego el id o llego pero no es un usuario del tipo administrador, se desecha
  #   el id es:$datosUser[0][0]  
  #   el nombre$datosUser[0][1]
  #   AP$datosUser[0][2]<br>
  #   AM$datosUser[0][3]<br>
  #   LOG$datosUser[0][4]<br>
  #   PASS$datosUser[0][5]<br>
  #   TIPO$datosUser[0][6]<br>
  #   GRUPO$datosUser[0][7]<br>

if ($id_normal eq "" || $datosUser[0][6] ne "3"){
    $contents = "Los datos de validacion de usuario para ejecutar este modulo no llegaron completos o no fueron insertados, consulte con el administrador del sistema o  <a href=valida.pl?accion=1>vuelva a intentar.</a>\n<br>
   llego $id_normal<br>
tipo $datosUser[0][6]";

    print $page_up.$contents.$botones.$page_down;	
}else{
    if($accion ne "1" && $accion ne "2" && $accion ne "3"){
    #esto despliega el menu de las operaciones con el usuario si aun no se ha definido una accion a realizar
   
	$contents="<table align=center><tr><td>
   <li><A HREF=\"#\" OnClick=\"window.open('opUsuarios.pl?accion=1\&dato_id=$id_normal','variable','width=600,height=450,scrollbars=yes,toolbar=no')\">Nuevo Usuario</A><br>
   <li><A HREF=\"#\" OnClick=\"window.open('opUsuarios.pl?accion=2\&dato_id=$id_normal','variable','width=600,height=450,scrollbars=yes,toolbar=no')\">Modificar datos del usuario</A><br>
   <li><A HREF=\"#\" OnClick=\"window.open('opUsuarios.pl?accion=3\&dato_id=$id_normal','variable','width=600,height=450,scrollbars=yes,toolbar=no')\">Borrar Usuario</A><br>
   </td></tr></table>\n";

	print $page_up.$contents.$botones.$page_down;	
    }elsif ($accion eq "1"){
    #insercion de usuario
      Pg::doQuery($conn,"select id_grupo,descripcion from grupos where estatus <> 0",\@grupos);
      Pg::doQuery($conn,"select * from tipoUsuario",\@tiposUsuario);

	print $page_up;	
	$contents_up="<table align=center><tr><td>
        MODULO DE ALTA DE USUARIOS AUDIT-ADMIN
        <form name=InsertaUser action=insertUser.pl>
        Para dar de alta nuevos usuarios es necesario insertar los siguientes datos:<br>
        <table>
        <tr><td><p>Nombre del usuario<br>
        <input type=\"text\" name=\"nombre\" maxlength=\"30\" size=\"30\"></p></td>
        <td><p>Apellido Paterno<br>
        <input type=\"text\" name=\"apaterno\" maxlength=\"30\" size=\"30\"></p>
        </td></tr><tr><td><p>Apellido Materno<br>
        <input type=\"text\" name=\"amaterno\" maxlength=\"30\" size=\"30\"></p>
        </td><td><p>Login<br>
        <input type=\"text\" name=\"login\" maxlength=\"20\" size=\"20\"></p>
        </td></tr><tr><td><p>Password<br>
        <input type=\"password\" name=\"password\" maxlength=\"30\" size=\"30\">
        <input type=\"hidden\" name=\"dato_id\" value=$id_normal>
        </td><td>";
	print $contents_up;
	#seleccion de grupo para el usuario 
	print "Seleccione un grupo al que el usuario pertenecer&aacute;:
        <SELECT NAME=\"grupo\"><br>";

	$x = 0;
	while ( $grupos[$x][0] ne "" ) {

	    print "<OPTION value=$grupos[$x][0]>$grupos[$x][1]\n";

	    $x ++;
	}
	print "</SELECT><br><br>";
        #seleccion de tipo de usuario
	print "</td></tr><td>Seleccione el tipo de usuario que se dar&aacute; de alta:
        <SELECT NAME=\"TipoUsuario\"><br>";

	$x = 0;
	while ( $tiposUsuario[$x][0] ne "" ) {

	    print "<OPTION value=$tiposUsuario[$x][0]>$tiposUsuario[$x][1]\n";

	    $x ++;
	}
	print "</SELECT><br><br>"; 	 
	$contents_down = "</td></tr>
        <tr><td align=right><input type=submit value=\"Insertar Usuario\"></td>
        <td align=left><input type=button value='Cancelar' onclick='self.close()'> 
        </td></tr></table>
        </form>
        </td></tr></table>\n";

	print $contents_down.$page_down;	

    }elsif ($accion eq "2"){
     #modificacion de los datos del usuario

      Pg::doQuery($conn,"select apaterno,amaterno,nombre,id_usuario from usuarios order by apaterno",\@usuarios);

	print $page_up;

	if($dimension = @usuarios < 10){
	    $longitud = $dimension;
	}else {
	    $longitud = 10;
	}

	print "<form>Seleccione el usuario a modificar:
        <SELECT NAME=\"usuarios\" size=\"$longitud\" onChange=\"spawnWin(this.options)\" ><br>";

	$x = 0;

	while ( $usuarios[$x][3] ne "" ) {

	    print "<OPTION value=modifUser.pl?dato_id=$id_normal\&id=$usuarios[$x][3]>\"$usuarios[$x][0] $usuarios[$x][1]  $usuarios[$x][2]\"\n";

	    $x ++;
	}

	print "</SELECT></form><br><br>";

	print $page_down;	    


    }elsif ($accion eq "3"){
      Pg::doQuery($conn,"select apaterno,amaterno,nombre,id_usuario from usuarios order by apaterno",\@usuarios);

	print $page_up;

	if($dimension = @usuarios < 10){
	    $longitud = $dimension;
	}else {
	    $longitud = 10;
	}

	print "<form>Seleccione el usuario a modificar:
        <SELECT NAME=\"usuarios\" size=\"$longitud\" onChange=\"spawnWin(this.options)\" ><br>";

	$x = 0;

	while ( $usuarios[$x][3] ne "" ) {

	    print "<OPTION value=delUser.pl?dato_id=$id_normal\&id=$usuarios[$x][3]>\"$usuarios[$x][0] $usuarios[$x][1]  $usuarios[$x][2]\"\n";

	    $x ++;
	}

	print "</SELECT></form><br><br>";

	print $page_down;	    

    }

}#cierre del else 

exit;
