#!/usr/bin/perl

$/ = "\n \n";

$qref = 1;

($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);

$mon++;
$my_time = "$mon / $mday / $year, $hour : $min";

while (<>) {

	while (/include::(([^:]|:[^:])*)::/) {
	
		$inc = "";
		open INCLUDE, "<$1";
		$inc = join('', <INCLUDE>);
		close INCLUDE;
		
		$inc =~ s/</&lt;/g;
		$inc =~ s/>/&gt;/g;
		s/include::(([^:]|:[^:])*)::/$inc/;
	}

	s/rem::(([^:]|:[^:])*):://g;
	s/mail::(([^:]|:[^:])*)::/<a href="mailto:\1">&lt;\1&gt;<\/a>/g;
	s/date::(([^:]|:[^:])*)::/\1<i>$my_time<\/i>/g;

	while (s/section::(([^:]|:[^:])*)::/<section qref=$qref>\1<\/section>/) {
		$section[$qref] = $1;
	}
	
	while (s/q::(([^:]|:[^:])*)::/<question qref=$qref>\1<\/question>\n/) {
		$qref++;
		push @idx, $1;
	}

	s/a::(([^:]|:[^:])*)::/<answer>\1<\/answer>\n/g;
	
	push @out, $_;
	
}

while ($_ = shift @out) {

	if (/index::(([^:]|:[^:])*)::/) {
		$idx_print = "\n$1\n<qindex>\n";
		$qref = 1;
		$first_sec = 1;
		
		while ($b = shift @idx) {
			if (defined $section[$qref]) {
				if ($first_sec) {
					$first_sec = 0;
				} else {
					$idx_print .= "</idxsec>\n";
				}

				$idx_print .= "<idxsec title=\"${section[$qref]}\">\n";
			}
			
			$idx_print .= "<idxq qref=\"${qref}\">$b</idxq>\n";
			$qref++;
		}
		
		$idx_print .= "<\/idxsec>\n" if (! $first_sec);
		$idx_print .= "</qindex>\n";
		
		s/index::(([^:]|:[^:])*)::/$idx_print/;
	}
	
	print $_;
}
