#!/usr/bin/perl  -U

###############################################################
#Proyecto de Tesis Auditoria Administrativa

#Copyright (C)2002 Cynthia Gabriela Pardo Orozco FCA-UNAM

#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
###############################################################

use Pg;
use CGI qw(:standard);
use pemes::inicializar;

$JSCRIPT=<<EOF;
var nombreInput;
var total=0;
var ids,value1;
function doString(nombreInput,valor){
    ids=nombreInput+":"+ids;
    value1=valor.toString()+":"+value1;
    valor++;
    total=valor + total;
    total=total -1 ;
}

function sumar (c) {
    var miForma;
    var v, total, lacol;
    var losIds, subfunciones;
    var eltotal, elInput, numerin;

    miForma = document.forma; 
    v = total = numerin = 0;
    losIds = miForma.ids_matriz.value.split(":");
    subfunciones = miForma.ids_sub.value.split (":");
    eltotal="",elInput="";

    while (v < losIds.length) {
	 lacol = losIds[v].split("x");
	 if(lacol[1] == c) {
	     elInput = "miForma.i" + losIds[v] + ".value";
	     numerin = parseInt (eval (elInput));
	     if (isNaN (numerin)) {
		 numerin = 0;
	     }
	     total = total + numerin;
	     eltotal = "miForma.totalitox" + lacol[1] + ".value=" + total;
	     eval (eltotal);
	 }
       v ++;
     } 
}

function guardar(){
    var miForma=document.forma; 
    var separator=":";
    var separa="x";

    var subfunciones1=miForma.ids_sub.value;
    var subfunciones=subfunciones1.split(separator);

    var totales1=miForma.puntosTotales.value;
    var totales=totales1.split(separator);
    var eltotal="",elInput="";
    var losIds1=miForma.ids_matriz.value;
    var losIds=losIds1.split(separator);
    var c=0,v=0,limite=subfunciones.length,limiteIds=losIds.length,total=0;
    var lacol;
    var numerin = 0;

  while (c < limite) {
     while (v < limiteIds) {
	 lacol=losIds[v].split(separa);
	 if(lacol[1]==subfunciones[c]){
	     elInput="miForma.i"+losIds[v] + ".value";
	     numerin = parseInt (eval (elInput));
	     if (numerin == 0) {
		 alert ("Ningun campo puede ser 0");
		 break;
	     }
	     total=total+numerin;
	     eltotal="miForma.totalitox"+lacol[1]+".value="+total;
	     eval (eltotal);
	 }
       v++;
     } 

     if (isNaN (total)) {
	 alert ("Ningun campo puede quedar vacio");
	 break;
     }
     if (total != totales[c]){ 
	 alert ("El total es "+total+" y deberia ser "+ totales[c]+" en la columna "+subfunciones[c]);
	 break;
     }	 

     total=0;
     v=0;
     c++;
 }

   miForma.submit();

  
}

EOF
;




#abre conexion
$conn = Pg::connectdb("dbname=auditoria user=pardo");

$query = new CGI;

print $query->header;

print start_html(-title=>'Seleccion de Auditoria y Operacion Audit-Admin',
                 -script=>$JSCRIPT);

$accion = $query->param(accion);
$id_normal = $query->param(dato_id);
$id_audit = $query->param(audit);
$ids_sub = $query->param(ids_sub);


@variables = &prueba();
#variables que crean el formato de la pagina que se despliega    
$page_up = $variables[0];
$page_down = $variables[1];
#botones para el regreso
$locacion1 = $variables[2];
$locacion2 = $variables[3];    
$locacion3 = $variables[4];
$botones = $variables[5];
#terminan los formatos de la pagina




######################################
#Este es para checar el tipo de usuario
######################################

Pg::doQuery($conn,"select * from usuarios where id_usuario =$id_normal",\@datosUser);

#si no llego el id o llego pero no es un usuario del tipo administrador, se desecha
#   el id es:$datosUser[0][0]
#   el nombre$datosUser[0][1]
#   AP$datosUser[0][2]<br>
#   AM$datosUser[0][3]<br>
#   LOG$datosUser[0][4]<br>
#   PASS$datosUser[0][5]<br>
#   TIPO$datosUser[0][6]<br>
#   GRUPO$datosUser[0][7]<br>


#usuario no es del tipo correcto
if ($id_normal eq "" ||$datosUser[0][6] ne "1" ){
    $contents = "Los datos de validacion de usuario para ejecutar este modulo no llegaron completos o no fueron insertados, consulte con el administrador del sistema o  <a href=valida.pl?accion=1>vuelva a intentar.</a>\n<br> <br> ";

    print $page_up.$contents.$page_down;	
}else{
  #####################################
  #Si accion viene sin ningun contenido
  #####################################
    if($accion == 1){
#si accion viene 1 o sea se ha capturado la distribucion y se esta guardando ahora.
	$ids_matriz = $query->param(ids_matriz);
#este dato es importante porque contiene los nombres de los objetos por los que hay que preguntar

	@arreglo_inputs = split(/:/, $ids_matriz);
	$x = 0;
   print $page_up;




    
    #################################################
    #verifica si hay registros en la tabla evaluacion
    #################################################

      Pg::doQuery($conn,"select id_auditoria from evaluacion  where  id_auditoria=$id_audit",\@evaluadas);
      

    #################################################
    #cuando existen evaluaciones asignados con anterioridad
    #################################################
	if( $evaluadas[0][0] ne ""){
	    print $page_up."La auditoria seleccionada cuenta ya con evaluaciones asignadas, no es posible modificar la distribucion de puntos.<br> \n";

	    print $botones.$page_down;		  

	}    else{
	  
	 #para traer el nombre de la empresa
	  Pg::doQuery($conn,"select nombre_emp from empresa where id_empresa in (select id_empresa from auditoria where id_auditoria=$id_audit)",\@nombreEmp);

	    print "La distribucion de puntos quedo de la siguiente manera:<p>";
	    $checatotal = 0;

	while ($arreglo_inputs[$x] ne ""){
	    $elInput = "i$arreglo_inputs[$x]";
	    @losElementos = split(/x/, $arreglo_inputs[$x]);
	    $factor = $losElementos[0];
	    $subfun = $losElementos[1];
	    $valor_input = $query->param($elInput);
	    
	  Pg::doQuery($conn,"select nombre from cat_factores where id_factor=$factor",\@nombreFact);
	  Pg::doQuery($conn,"select nombre from cat_subfunciones where id_sub=$subfun",\@nombreSub);
	  Pg::doQuery($conn,"update distrib_puntos set puntos=$valor_input where id_auditoria=$id_audit and  id_sub='$subfun' and id_factor='$factor'");

	    $checatotal = $checatotal + $valor_input;
	    print "<li> $valor_input,factor $nombreFact[0][0], subfuncion $nombreSub[0][0]<p>";
	    $x ++;
	}    	   
	  Pg::doQuery($conn,"select sum(puntos) from distrib_puntos where id_auditoria=$id_audit",\@checa);
#para checar que lo que esta en la base sea lo que esta en pantalla
	    if($checatotal == $checa[0][0]){
		print "La insercion de puntos en la empresa <b>\" $nombreEmp[0][0] \"</b> se realizo con exito<br>\n"; 
	    }else{
		print "<font color=red>Fallo en la insercion de valores,vuelva a intentar o bien consulte con el administrador del sistema.</font><br>\n"; 
	    }
	    print $botones.$page_down;
    }

} else {

   ####################################################
   #AQUI VAN LAS SUBFUNCIONES CONTRA LOS FACTORES
   #Y PONER ESPACIOS PARA DISTRIBUIR LOS PUNTOS
   ####################################################   

	#trae las subfunciones existentes en la auditoria
      Pg::doQuery($conn,"select id_sub,nombre from cat_subfunciones where id_sub  in (select id_sub from ponderacion_sub where id_auditoria=$id_audit) order by id_sub",\@subfunciones);	  

      Pg::doQuery($conn,"select porcentaje from ponderacion_sub where id_auditoria=$id_audit order by id_sub",\@percentSub);
	  
      Pg::doQuery($conn,"select id_factor,nombre from cat_factores where id_factor  in (select distinct id_factor from distrib_puntos where id_auditoria=$id_audit)",\@factores);
	  
	$x = 0;	    
	$num_subfunciones = @subfunciones ;
	if ($num_subfunciones > 10 && scalar(@factores)>0 ){
	    $num = 10;
	}else{
	    $num = $num_subfunciones;
	    if($num > 0 && scalar(@factores)>0 ){
	    }else{
		$num = 0;
	    }
	}
	if($num > 0){
	    $contents_up = "
          - MODULO DE OPERACIONES CON AUDITORIAS - AUDIT-ADMIN \n 
          <p> \n
          <form method=post name=\"forma\" action=\"defineDistrib.pl\"> \n
          <table><tr>\n";

	    print $page_up.$contents_up;
	  
	  
	    print "<tr><td colspan=5>Teclee la distribucion de puntos:</td></tr><tr><td>&nbsp;</td> \n";
	    $x = 0;
	  

	    while ( $subfunciones[$x][0] ne "" ) {   
		$subfunciones[$x][0] =~ s/ //g;
           #######################################################
           #para sacar los valores anteriores de las subfunciones
           #######################################################  
	      Pg::doQuery($conn,"select porcentaje from ponderacion_sub where id_sub=$subfunciones[$x][0]  id_auditoria=$id_audit)",\@percentExist);	  
		$percentSub[$x][0] = $percentSub[$x][0] * 10;
		print "<td alig=center><b> $subfunciones[$x][1]</b><p align=center>$percentSub[$x][0] </td>\n";
		$lasSubfunciones = "$lasSubfunciones:$subfunciones[$x][0]";
		$losTotales = "$losTotales:$percentSub[$x][0]";
		$x ++;
	    }
	    $x = 0;
	    $y = 0;
	    $lenSub = scalar(@subfunciones);
	    $limite = scalar(@factores);
	    while($x <= $limite){
		if($x < $limite){
		    print "<tr><td><b>$factores[$x][1]</b> </td>\n";
		}else{
		    print "<tr><td><b>TOTALES</b> </td>\n";
		}
		while ( $subfunciones[$y][0] ne "" ) {   
		    $factores[$x][0]=~ s/ //g;
		    $subfunciones[$y][0]=~ s/ //g;
		    if($x < $limite){
			$elementos="$factores[$x][0]x$subfunciones[$y][0]";
           #########################################################################################
           #para sacar los valores anteriores de la distribucion de puntos en caso de existir este
           ########################################################################################  
	      Pg::doQuery($conn,"select puntos from distrib_puntos where  id_auditoria=$id_audit and id_sub=$subfunciones[$y][0] and id_factor=$factores[$x][0]",\@puntosAnt);

			print "<td align=center><input type=text name=\"i$elementos\" size=4 onChange=\"sumar($subfunciones[$y][0])\" value=$puntosAnt[0][0]> </td><!--Los nombres de estos objetos se forman con el factor, equis (x) la subfuncion-->\n";
#	     print "ELEMENTOS $elementos<br>";
			$losIds="$losIds:$elementos";
		    }else{
			print "<td align=center><input type=text name=\"totalitox$subfunciones[$y][0]\"  size=4> </td><!--Los nombres de estos objetos totales se forman del total guin la subfuncion-->\n";
		    }
		    $y++;
		}

		$y=0;
		print "</tr>";    
		print "";    
		$x++;
	    }

	    $losIds =~s/^://;
	    #estas son las variables que le permiten al cgi saber cuantas subfunciones o bien columnas hay que revizar y cuales son los totales a los que tiene que llegar la suma de cada columna
	    $lasSubfunciones =~s/^://;
	    $losTotales =~s/^://;
	    
	    $contents2_down = "</tr></table><br>\n

       <input class=\"sbttn\" style=\"width: 75px;\" type=\"button\" value=\"Guardar\" name=\"Guardar\" onClick=\"guardar();\n\">
       <input type=\"hidden\" name=\"dato_id\" value=\"$id_normal\">\n
       <input type=\"hidden\" name=\"audit\" value=\"$id_audit\">\n
       <input type=\"hidden\" name=\"ids_sub\" value=\"$lasSubfunciones:\">\n
       <input type=\"hidden\" name=\"puntosTotales\" value=\"$losTotales:\">\n
       <input type=\"hidden\" name=\"ids_matriz\" value=\"$losIds\">\n
       <input type=\"hidden\" name=\"accion\" value=1>\n
        </form>\n";
	  
	    print $contents2_down.$botones.$page_down;
	}else {
#cuando no existen auditorias creadas.
	    print $page_up;
	    print "La auditoria seleccionada no contiene subfunciones asignadas con pesos relacionados<br>\n
       o bien,no contiene aun Factores asociados. \n";
	    print $empresas[$x][0];
	    print $botones.$page_down;	  
	}
    }
}
#cierre del else 

exit;

