#!/usr/bin/perl  -U

###############################################################
#Proyecto de Tesis Auditoria Administrativa

#Copyright (C)2002 Cynthia Gabriela Pardo Orozco FCA-UNAM

#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
###############################################################

use Pg;
use CGI qw(:standard);
use pemes::inicializar;

$JSCRIPT = <<EOF;
var destQAL = document.editQALForm.destQAL;
var ie = document.all?1:0;
var submited = 0;

function validaP() {
//Esta funcion se utiliza solo para validar la insercion al catalogo de preguntas.

    var miForma = document.editQALForm;    
 
    if (miForma.preguntas.value == ""){
	alert("Es necesario seleccionar una pregunta del catalogo o insertar una nueva");
	miForma.newName.focus();

    }else if(miForma.subfuncion.value == ""){

	alert("Es necesario selecionar una subfuncion a la cual relacionar la pregunta");	

   }else if(miForma.factor.value == ""){

	alert("Es necesario selecionar un factor al cual relacionar la pregunta");	
    }else{

	document.miForma.submit();

    } 
}

function guardaSelect(){
    var miForma = document.editQALForm;    
    var longitud=miForma.destQAL.length;
    var i=0;
    var ids="";

    while (i < longitud){
    
	ids=miForma.destQAL.options[i].value+":"+ids ;
 
	i++;

    }
    miForma.ids_preg.value=ids;
  
    miForma.submit();

}    
EOF
;




#abre conexion
$conn = Pg::connectdb("dbname=auditoria user=pardo");

$query = new CGI;

print $query->header;

print start_html(-title=>'Seleccion de Auditoria y Operacion Audit-Admin',
                 -script=>$JSCRIPT);

$accion = $query->param(accion);

$id_normal = $query->param(dato_id);

$id_audit = $query->param(audit);

$ids_preg = $query->param(ids_sub);


@variables = &prueba();
#variables que crean el formato de la pagina que se despliega    
$page_up = $variables[0];
$page_down = $variables[1];
#botones para el regreso
$locacion1 = $variables[2];
$locacion2 = $variables[3];    
$locacion3 = $variables[4];
$botones = $variables[5];
#terminan los formatos de la pagina




##########################################
#Este es para checar el tipo de usuario
##########################################

Pg::doQuery($conn,"select * from usuarios where id_usuario =$id_normal",\@datosUser);

#si no llego el id o llego pero no es un usuario del tipo administrador, se desecha
#   el id es:$datosUser[0][0]
#   el nombre$datosUser[0][1]
#   AP$datosUser[0][2]<br>
#AM$datosUser[0][3]<br>
#   LOG$datosUser[0][4]<br>
#PASS$datosUser[0][5]<br>
#TIPO$datosUser[0][6]<br>
#GRUPO$datosUser[0][7]<br>


#usuario no es del tipo correcto
if ($id_normal eq "" ||$datosUser[0][6] ne "1" ){
    $contents = "Los datos de validacion de usuario para ejecutar este modulo no llegaron completos o no fueron insertados, consulte con el administrador del sistema o  <a href=valida.pl>vuelva a intentar.</a>\n<br> <br> ";

    print $page_up.$contents.$page_down;	
}else{
#######################################
#Si accion viene sin ningun contenido
#######################################
    if($accion == 1){
    #cuando es llamado por segunda ocasion para guardar los datos
    #
    #  para recoger los id's de las subfunciones seleccionadas
      $id_preg = $query->param(preguntas);
      $id_sub =$query->param(sunfunciones);     
      $id_factor =$query->param(factores);
      $newQuestion = $query->param(newQuestion);

      if ($newQuestion ne ""){
        Pg::doQuery($conn,"select (max(id_pregunta)) FROM cat_preguntas",\@maximo);
	$maximo[0][0] ++;
	Pg::doQuery($conn,"insert into cat_preguntas values ($maximo[0][0],'$newQuestion')");
      }  

      #me quede en que hay que hacer la validacion para insertar mas preguntas y 
      #que hay que insertar las preguntas que se seleccionaron para posteriormente calificarlas
      Pg::doQuery($conn,"select respuesta, id_grado from evaluacion  where  id_auditoria=$id_audit",\@evaluadas);
      if( $evaluadas[0][0] > 0 || $evaluadas[0][1] > 0 ){
	    print $page_up."La auditoria seleccionada contiene preguntas evaluadas, no es posible agregar preguntas una vez que ha comenzado la evaluacion \n";

	    print $botones.$page_down;		  

      }else{
	  
         #borra las subfunciones existentes 
	  Pg::doQuery($conn,"delete from evaluacion  where  id_auditoria=$id_audit and respuesta='' and id_grado='' ");
         #inserta las nuevas subfunciones
##hay que adaptar los cambios que hice para las preguntas
	    $x = 0;
	    while ($x < $longitud ){  
	      Pg::doQuery($conn,"insert into evaluacion (id_auditoria,id_pregunta) values($id_audit,$ids_preg[$x])");

		$x++;   
	    }
	   
	 #para traer el nombre de la empresa
	  Pg::doQuery($conn,"select nombre_emp from empresa where id_empresa in (select id_empresa from auditoria where id_auditoria=$id_audit)",\@nombreEmp);
	   
	    print $page_up."La insercion de preguntas en la auditoria a la empresa <b>\" $nombreEmp[0][0] \"</b> se realizo con exito<br>\n"; 

	    print $botones.$page_down;
      }

    }else{

     #trae las subfunciones y factores que se eligieron con anterioridad 
      Pg::doQuery($conn,"select distinct id_sub from distrib_puntos  where id_auditoria=$id_audit;",\@subfun);
#para hacer una cadena que ayude a formar el query que solo traiga las preguntas en el catalogo correspondientes a las subfunciones y factores anteriormente seleccionados

	$limite = scalar(@subfun);
	$x = 0;
	$first = 0;
	while($x < $limite){
	    if ($first == 0){
		$subfun[$x][0] =~ s/ //g;
		$cadenaSub="id_sub='$subfun[$x][0]'";	       
		$first = 1;
	    }else{
		$cadenaSub="$cadenaSub or id_sub='$subfun[$x][0]'";	       
	    }
	    $x ++;
	}

 
      Pg::doQuery($conn,"select distinct id_factor from distrib_puntos  where id_auditoria=$id_audit;",\@factores);

	$limite = scalar(@factores);
	$x = 0;
	$first = 0;
	while($x < $limite){
	    if ($first == 0){
		$factores[$x][0] =~ s/ //g;
		$cadenaFact="id_factor='$factores[$x][0]'";	       
		$first = 1;
	    }else{
		$cadenaFact="$cadenaFact or id_factor='$factores[$x][0]'";	       
	    }   
	    $x ++;
	}

      Pg::doQuery($conn,"select id_pregunta, descripcion  from cat_preguntas where id_pregunta not  in (select id_pregunta from evaluacion where id_auditoria=$id_audit)",\@catPreguntas);

#	print "select id_pregunta, descripcion  from cat_preguntas where id_pregunta not  in (select id_pregunta from evaluacion where id_auditoria=$id_audit)";

#####################################################################################
# Trae todas las preguntas y solo las subfunciones y factores elegidos, es entonces #
# cuando el usuario define que una pregunta pertenece a una subfuncion y factor     #
#####################################################################################
#      Pg::doQuery($conn,"select id_pregunta, descripcion  from cat_preguntas where id_pregunta in (select id_pregunta from evaluacion where id_auditoria=$id_audit)",\@lasPreguntas);	  


	$x = 0;	    
	$num_preguntas = @catPreguntas ;
	if ($num_preguntas > 5){
	    $num = 5;
	}else{
	    $num = $num_preguntas;
	    if($num == 0){
		$num = scalar(@catPreguntas);
	    }
	}
	if($num > 0){
	     Pg::doQuery($conn,"select nombre,id_sub FROM cat_subfunciones where id_sub in(select id_sub from distrib_puntos where id_auditoria=$id_audit)order by nombre",\@catSubfunciones);
	     Pg::doQuery($conn,"select nombre,id_factor FROM cat_factores where id_factor in (select id_factor from distrib_puntos where id_auditoria=$id_audit)order by nombre",\@catFactores);

	    $contents_up = "
            - MODULO DE OPERACIONES CON AUDITORIAS -Definicion de Preguntas - AUDIT-ADMIN - \n 
            <p>\n
            <form method=post name=\"editQALForm\">\n
            <table><tr>\n
            <td valign=\"middle\" align=\"center\">";
            
	    $contents2 = "<tr><td valign=\"middle\" align=\"center\"><br>\n
 
            </td></tr><tr><td valign=\"middle\" align=\"center\">\n";
	  
	    print $contents2;
	  
#	    print "Preguntas elegidas:<br><SELECT NAME=\"destQAL\" size=\"5\" width=\"300px\" style=\"width:300px;\"><br>\n";
#	    $x = 0;

#	    while ( $lasPreguntas[$x][0] ne "" ) {   
#		print "<OPTION value=$lasPreguntas[$x][0]>$lasPreguntas[$x][1] \n";
#		$x++;
#	    }
	  
#	    print "</select></td></tr></table>\n";
	    print "</td></tr>\n
            <tr><td>OTRA:<input type=\"text\" name=\"newQuestion\" size=\"70\"></td></tr>
</table>\n";

	    print "<table><tr><td>Subfunciones<br>\n
            <SELECT NAME=\"subfunciones\" size=\"3\" onChange=daleValue(this.options,'sub')>";

	    $x = 0;
	    while ( $catSubfunciones[$x][0] ne "" ) {
#imprime las subfunciones existentes en el catalogo
		$catSubfunciones[$x][1] =~ s/ //g;
		print "<OPTION value=\"$catSubfunciones[$x][1]\">$catSubfunciones[$x][0]\n";

		$x ++;
	    }

	    print"</SELECT></td>
            <td>Factores<br>
	    <SELECT NAME=\"factores\" size=\"3\" onChange=daleValue(this.options,'fact')>";

	    $x = 0;

	    while ( $catFactores[$x][0] ne "" ) {

#imprime los factores existentes en el catalogo
		$catFactores[$x][1] =~ s/ //g;
		print "<OPTION value=\"$catFactores[$x][1]\">$catFactores[$x][0]\n";

		$x ++;
	    }

	    print"            </SELECT>
            </td></tr></table>\n
            <p><div align=center><input type=\"button\" value=\"Aceptar\" Onclick=\"validaP()\"></div></p>

 
            <input type=\"hidden\" name=\"dato_id\" value=\"$id_normal\">\n
            <input type=\"hidden\" name=\"audit\" value=\"$id_audit\">\n
            <input type=\"hidden\" name=\"accion\" value=1>\n
            </form>";

           print $botones.$page_down;
	}else {
#cuando no existen auditorias creadas.
	    print $page_up;
	    print "<p align=center>No hay auditorias existentes<br>O que cumplan con los contenidos necesarios para realizar este paso,Verifique haber llevado a cabo los pasos anteriores para la realizacion de auditorias o bien \n
            Requiere crear una auditoria previamente</p>";
	    print $empresas[$x][0];
	    print $botones.$page_down;	  
	}
    }
}
#cierre del else 

exit;

