#!/usr/bin/perl  -U

###############################################################
#Proyecto de Tesis Auditoria Administrativa

#Copyright (C)2002 Cynthia Gabriela Pardo Orozco FCA-UNAM

#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
###############################################################

use Pg;
use CGI qw(:standard); 
use pemes::inicializar;


#abre conexion
$conn = Pg::connectdb("dbname=auditoria user=pardo");

$query = new CGI;

print $query->header;

$JSCRIPT = <<EOF;
var nombreInput;
var total = 0;
var ids,value1;

function doString(nombreInput,valor){
    ids = nombreInput+":"+ids;
    value1 = valor.toString()+":"+value1;
    valor++;
    total = valor + total;
    total = total -1 ;
}

function guardar(){
 miForma = document.forma1; 
 var cadena = miForma.auxiliar.value;
 var separator = ":";
 var arregloIds = cadena.split(separator);
 var limite = arregloIds.length -1;
 var losContenidos = "";
 for (var i = 0; i < limite; i++){
     elInput = "miForma"+".i"+arregloIds[i]+".value;";
     numerito = parseInt (eval(elInput));
     total = total + numerito;
     losContenidos += numerito + ":";     
 }
 if (total < 100 && total > 0){
     alert("La suma de las subfunciones debe dar 100% o bien 0 si se desea mantener en blanco");
     total = 0;
     losContenidos = "";

 }else if(eval(total) > 100){
     alert("La suma de las subfunciones no puede ser mayor al 100%");
     total = 0;
     losContenidos = "";

 }else{
     losContenidos = losContenidos+"0";
     miForma.porcentajes.value = losContenidos;
     cadena = cadena+"0";
     miForma.ids_sub.value = cadena;
     //alert(losContenidos);
     miForma.submit();
 }
  
}

EOF
;

print start_html(-title=>'Seleccion de Auditoria y Operacion Audit-Admin',
                 -script=>$JSCRIPT);

$accion = $query->param(accion);

$id_normal = $query->param(dato_id);

$id_audit = $query->param(audit);

$ids_sub = $query->param(ids_sub);


@variables = &prueba();
#variables que crean el formato de la pagina que se despliega    
$page_up = $variables[0];
$page_down = $variables[1];
#botones para el regreso
$locacion1 = $variables[2];
$locacion2 = $variables[3];    
$locacion3 = $variables[4];
$botones = $variables[5];
#terminan los formatos de la pagina




######################################
#Este es para checar el tipo de usuario
######################################

Pg::doQuery($conn,"select * from usuarios where id_usuario =$id_normal",\@datosUser);

#si no llego el id o llego pero no es un usuario del tipo administrador, se desecha
#   el id es:$datosUser[0][0]
#   el nombre$datosUser[0][1]
#   AP$datosUser[0][2]<br>
#AM$datosUser[0][3]<br>
#   LOG$datosUser[0][4]<br>
#PASS$datosUser[0][5]<br>
#TIPO$datosUser[0][6]<br>
#GRUPO$datosUser[0][7]<br>


#usuario no es del tipo correcto
if ($id_normal eq "" ||$datosUser[0][6] ne "1" ){
    $contents = "Los datos de validacion de usuario para ejecutar este modulo no llegaron completos o no fueron insertados, consulte con el administrador del sistema o  <a href=valida.pl?accion=1>vuelva a intentar.</a>\n<br> <br> ";

    print $page_up.$contents.$page_down;	
}else{
####################################
#Si accion viene sin ningun contenido
###################################
    if($accion == 1){
#  para recoger los id's de las subfunciones seleccionadas
	$ids_sub = $query->param(ids_sub);
	$cadenita = $ids_sub;    
	@ids_sub = split(/:/, $ids_sub);
	$lengIds = @ids_sub;
	$porcentajes = $query->param(porcentajes);
#    $porcientos=$porcentajes;    
	@porcentajes = split(/:/, $porcentajes);
	$lengPercent = @porcentajes;
	$lengPercent = $lengPercent-1;
    
#################################################
#verifica si hay subfunciones con pesos asignados
################################################

      Pg::doQuery($conn,"select puntos from distrib_puntos  where  id_auditoria=$id_audit",\@puntos);

################################################
#cuando existen puntos asignados con anterioridad
################################################
	if( $puntos[0][0] ne ""){
	    print $page_up."La auditoria seleccionada cuenta ya con puntos asignados, que son el comienzo de una evaluacion, no es posible insertar nuevos pesos cuando se ha realizado la distribucion de puntos.<br> \n";

	    print $botones.$page_down;		  

	}else{
	  
#borra las pesos existentes 
	  Pg::doQuery($conn,"update  ponderacion_sub set porcentaje=0 where  id_auditoria=$id_audit");
#inserta las nuevas subfunciones
	    $x = 0;
	    while ($x < $lengPercent ){  

	      Pg::doQuery($conn,"update ponderacion_sub  set porcentaje=$porcentajes[$x] where id_sub='$ids_sub[$x]' and  id_auditoria=$id_audit");

#para verificar si se realizo la insercion sin errores  
		$x++;   
	    }
	   
#para traer el nombre de la empresa
	  Pg::doQuery($conn,"select nombre_emp from empresa where id_empresa in (select id_empresa from auditoria where id_auditoria=$id_audit)",\@nombreEmp);

	    print $page_up."La insercion de pesos en la empresa <b>\" $nombreEmp[0][0] \"</b> se realizo con exito<br>\n"; 

	    print $botones.$page_down;
	}

 }else{
####################################################
#AQUI HAY QUE PONER LAS SUBFUNCIONES DE LA AUDITORIA
#Y DESPUES DAR PARA PONER LOS PORCENTAJES
####################################################   

#trae las subfunciones existentes en la auditoria
   Pg::doQuery($conn,"select id_sub,nombre from cat_subfunciones where id_sub  in (select id_sub from ponderacion_sub where id_auditoria=$id_audit)",\@subfunciones);	  

     $x = 0;	    
     $num_subfunciones=@subfunciones ;
     if ($num_subfunciones > 10){
	 $num = 10;
     }else{
	 $num = $num_subfunciones;
     }
     if($num > 0){
	 $contents_up = "
          - MODULO DE OPERACIONES CON AUDITORIAS - AUDIT-ADMIN \n 
          <p> \n
          <form method=post name=\"forma1\" action=\"defineWeight.pl\"> \n
          <table><tr>\n";

	 print $page_up.$contents_up;
	  
	  
	 print "<tr><td colspan=2>Teclee el peso de cada subfuncion asignada:</td></tr> \n";

	 $x = 0;

	 $losIds;

	 while ( $subfunciones[$x][0] ne "" ) {   

	     $subfunciones[$x][0] =~s/ //g;

#        Pg::doQuery($conn,"select porcentaje from ponderacion_sub where id_sub=$subfunciones[$x][0]  id_auditoria=$id_audit)",\@percentExist);	  

	     print "<td> $subfunciones[$x][1] </td>
         <td> <input type=\"text\"  maxlength=\"6\" name=\"i$subfunciones[$x][0]\"></td></tr> \n";
	     $vari = $subfunciones[$x][0];

	     $losIds = "$vari:$losIds";

	     $x ++;
	 }

	 $numerito = scalar(@subfunciones);
	 $contents2_down = "</table><br>\n
         <input class=\"sbttn\" style=\"width: 75px;\" type=\"button\" value=\"Guardar\" name=\"Guardar\" onClick=\"guardar();\n\">
         <input type=\"hidden\" name=\"dato_id\" value=\"$id_normal\">\n
         <input type=\"hidden\" name=\"audit\" value=\"$id_audit\">\n
         <input type=\"hidden\" name=\"ids_sub\" value=\"\">\n
         <input type=\"hidden\" name=\"auxiliar\" value=\"$losIds\">\n
         <input type=\"hidden\" name=\"porcentajes\" value=\"\">\n
         <input type=\"hidden\" name=\"accion\" value=1>\n
         </form>\n";
	  
	 print $contents2_down.$botones.$page_down;


     }else {
#cuando no existen auditorias creadas.
	 print $page_up;

	 print "La auditoria seleccionada no contiene subfunciones asignadas<br>\n
         Requiere asociar subfunciones a una auditoria con anterioridad para realizar esta operacion \n";

	 print $empresas[$x][0];

	 print $botones.$page_down;	  
     }
 }

}
#cierre del else 

exit;
