#!/usr/bin/perl  -U

###############################################################
#Proyecto de Tesis Auditoria Administrativa

#Copyright (C)2002 Cynthia Gabriela Pardo Orozco FCA-UNAM

#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
###############################################################

use Pg;
use CGI qw(:standard);
use pemes::inicializar;

###############################################################
#la siguiente funcion javascript sirve para cambiar la pagina de
#manera automatica una vez que el usuario ha elegido una operacion
#a realizar, enviando los datos necesarios.
###############################################################

$JSCRIPT=<<EOF;

function spawnWin(options) {
 var url = options[
  options.selectedIndex
  ].value;
 parent.location.href= url;
}
 

 
EOF
; 


$conn = Pg::connectdb("dbname=auditoria user=pardo");

$query = new CGI;
print $query->header;
print start_html(-title=>'Personal Profile',
                 -script=>$JSCRIPT);

$accion = $query->param(accion);
$id_normal = $query->param(dato_id);


@variables= &prueba();
#variables que crean el formato de la pagina que se despliega    
$page_up=$variables[0];
$page_down=$variables[1];
#botones para el regreso
$locacion1=$variables[2];
$locacion2=$variables[3];    
$locacion3=$variables[4];
$botones=$variables[5];
#terminan los formatos de la pagina




Pg::doQuery($conn,"select * from usuarios where id_usuario =$id_normal",\@datosUser);

#si no llego el id o llego pero no es un usuario del tipo administrador, se desecha
  #   el id es:$datosUser[0][0]  
  #   el nombre$datosUser[0][1]
  #   AP$datosUser[0][2]<br>
  #   AM$datosUser[0][3]<br>
  #   LOG$datosUser[0][4]<br>
  #   PASS$datosUser[0][5]<br>
  #   TIPO$datosUser[0][6]<br>
  #   GRUPO$datosUser[0][7]<br>

if ($id_normal eq "" || $datosUser[0][6] ne "1"){
   $contents="Los datos de validacion de usuario para ejecutar este modulo no llegaron completos o no fueron insertados, consulte con el administrador del sistema o  <a href=valida.pl?accion=1>vuelva a intentar.</a>\n<br>
   ";

   print $page_up.$contents.$botones.$page_down;	
}else{
 if($accion ne "2" && $accion ne "3"){
  #modificacion de los datos dela empresa

    Pg::doQuery($conn,"select id_empresa,nombre_emp from empresa where id_empresa not in (select id_empresa from auditoria)",\@empresas);
    print $page_up;
	 
   if($dimension=@empresas > 0){
     if($dimension < 10){
	  $longitud=$dimension;
     }else {
	  $longitud=10;
     }
     print "<form>El siguiente listado solo presenta empresas a las que no se han asignado auditorias. Si la empresa que busca no se encuentra en el listado puede significar que tiene auditorias asignadas y no puede ser borrada del Catalogo con el fin de conservar la integridad de los datos.<br>
Seleccione la empresa a eliminar:
    <div align=center>
    <SELECT NAME=\"usuarios\" size=\"$longitud\" onChange=\"spawnWin(this.options)\" ><br>";
              print "<OPTION>Elija:\n";
     $x = 0;
       while ( $empresas[$x][0] ne "" ) {

              print "<OPTION value=opEmpDel.pl?dato_id=$id_normal\&id=$empresas[$x][0]&accion=2>\"$empresas[$x][1]\"\n";

          $x++;
       }
     print "</SELECT>
     </div>

     </form><br><br>";

     print $botones.$page_down;
	
 	}else{#si no hay empresas para modificar

	   print "Por el momento no existen empresas con permiso para ser editadas, verifique que la empresa por seleccionar no este siendo utilizada por una auditoria";
        print $botones.$page_down;    
	}#cierre else de empresas a modificar
	    

    }elsif($accion eq "2"){
       print $page_up;
	 
     $id = $query->param(id);

     Pg::doQuery($conn,"delete from empresa  where id_empresa='$id'");

     $contents="La empresa se elimino con exito <br>
     <form><input type=\"button\" value=\"Eliminar Otra empresa\" onclick=\"parent.location.href='opEmpDel.pl?dato_id=$id_normal'\" ></form>";

	  #///////
	 
	  print $contents.$botones.$page_down;


	}elsif($accion eq "3"){
    $id = $query->param(id);	  
    $nameEmpresa = $query->param(nombreEmp);
    $dateFundation = $query->param(fechaFundacion);
    $clasificacion = $query->param(clasificacion);
    $giro = $query->param(giro);
    $nameContact = $query->param(nombreContacto);        
    $firstContact = $query->param(aPaterno);
    $secondContact = $query->param(aMaterno);    
    $phoneContact = $query->param(telefono);
    $streetEmpresa = $query->param(calle);
    $numberEmpresa = $query->param(numero);
    $coloniaEmpresa = $query->param(colonia);
    $cpEmpresa = $query->param(cp);
    $municipioEmpresa = $query->param(municipio);
    $estateEmpresa = $query->param(estado);
    $delegacionEmpresa = $query->param(delegacion);

    $contents="Los datos recibidos y actualizados son:<br>
    <table>
    <tr><td>ID:</td><td> $id </tr>
    <tr><td>Nombre de la empresa:</td><td> $nameEmpresa </tr>
    <tr><td>Fecha de fundacion:</td><td> $dateFundation </tr>
    <tr><td>Clasificacion:</td><td> $clasificacion </tr>
    <tr><td>Giro :</td><td>$giro  </tr>
    <tr><td>Nombre del contacto:</td><td> $nameContact </tr>        
    <tr><td>Apellido Paterno del contacto:</td><td> $firstContact </tr>
    <tr><td>Apellido Materno del contacto:</td><td> $secondContact </tr>    
    <tr><td>Telefono del contacto:</td><td> $phoneContact </tr>
    <tr><td colspan=2>DOMICILIO DE LA ORGANIZACION:</tr>
    <tr><td>Calle: </td><td>$streetEmpresa </tr>
    <tr><td>Numero:</td><td> $numberEmpresa </tr>
    <tr><td>Colonia:</td><td> $coloniaEmpresa </tr>
    <tr><td>Cp:</td><td> $cpEmpresa </tr>
    <tr><td>Municipio:</td><td> $municipioEmpresa </tr>
    <tr><td>Estado:</td><td> $estateEmpresa </tr>
    <tr><td>Delegacion:</td><td> $delegacionEmpresa </tr>
    </table>
    ";

    #    $nameEmpresa <br>
    #    $dateFundation <br>
    #    $clasificacion <br>
    #    $giro  <br>
    #    $nameContact <br>        
    #    $firstContact <br>
    #    $secondContact <br>    
    #    $phoneContact <br>
    #    $streetEmpresa <br>
    #    $numberEmpresa <br>
    #    $coloniaEmpresa <br>
    #    $cpEmpresa <br>
    #    $municipioEmpresa <br>
    #    $estateEmpresa <br>
    #    $delegacionEmpresa 




    Pg::doQuery($conn,"update  empresa set id_clas='$clasificacion',id_giro='$giro',id_est='$estateEmpresa',id_del='$delegacionEmpresa',nombre='$nameContact',nombre_emp='$nameEmpresa',telefono='$phoneContact',a_paterno='$firstContact',a_materno='$secondContact',fecha_fundacion='$dateFundation',calle='$streetEmpresa',numero='$numberEmpresa',colonia='$coloniaEmpresa',cp='$cpEmpresa',municipio='$municipioEmpresa' where id_empresa='$id'");
        $nameEmpresa ="";
      $dateFundation = "";
      $clasificacion1 ="";	  
      $giro1 ="";
      $nameContact ="";        
      $firstContact ="";
      $secondContact ="";    
      $phoneContact ="";
      $streetEmpresa ="";
      $numberEmpresa ="";
      $coloniaEmpresa ="";
      $cpEmpresa ="";
      $municipioEmpresa ="";
      $estateEmpresa1 ="";
#    print "update  empresa set id_clas='$clasificacion',id_giro='$giro',id_est='$estateEmpresa',id_del='$delegacionEmpresa',nombre='$nameContact',nombre_emp='$nameEmpresa',telefono='$phoneContact',a_paterno='$firstContact',a_materno='$secondContact',fecha_fundacion='$dateFundation',calle='$streetEmpresa',numero='$numberEmpresa',colonia='$coloniaEmpresa',cp='$cpEmpresa',municipio='$municipioEmpresa' where id_empresa='$id'";

    #para cambiar el valor del estatus
#    Pg::doQuery($conn,"select estatus from grupos where id_grupo='$grupoUser'",\@estatus);
#    $estatus=$estatus[0][0]+1;
  
#    Pg::doQuery($conn,"update grupos set estatus='$estatus' where id_grupo='$grupoUser'");
    $boton="<form><input type=\"button\" value=\"Insertar Otra empresa\" onclick=\"parent.location.href='opEmpInsert.pl?dato_id=$id_normal'\" ></form>";
  
    print $page_up.$contents.$boton.$botones.$page_down;  
	
    


	  }

}#cierre del else 
 
exit;
